/* Copyright (c) Determina Corp. 2007.  All rights reserved.
 * 
 * This software and documentation constitute an unpublished work and contain
 * valuable trade secrets and proprietary information belonging to Determina
 * Corp.  None of the foregoing material may be copied, duplicated or
 * disclosed without the express written permission of Determina Corp.
 * DETERMINA CORP. EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING THIS
 * SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF MERCHANTABILITY
 * AND/OR FITNESS FOR ANY PARTICULAR PURPOSE, AND WARRANTIES OF PERFORMANCE,
 * AND ANY WARRANTY THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE
 * OF TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO THE USE
 * OF THE SOFTWARE OR DOCUMENTATION. Under no circumstances shall Determina
 * Corp. be liable for incidental, special, indirect, direct or consequential
 * damages or loss of profits, interruption of business, or related expenses
 * which may arise from use of software or documentation, including but not
 * limited to those resulting from defects in software and/or documentation,
 * or loss or inaccuracy of data of any kind.
 *
 * Determina Patch Engine external interface
 *
 */

#ifndef PATCH_H
#define PATCH_H

#if defined(__cplusplus)
extern "C" {
#endif

//
// Modules to patch
//

extern struct module {
    char* name;                 // DLL name

    struct hash {               // CRC32 checksum of the area around the patch
        unsigned int start;
        unsigned int length;
        unsigned int crc32;
    } hash;

    unsigned int patch_point;   // offset of the patch point
} modules[];

// Number of entries in the modules array
extern int num_modules;


//
// Function called to patch a module
//

void patch_module(struct module* module, char* image_base);


#if defined(__cplusplus)
}
#endif

#endif
